/* Copyright (C) 1991-2023 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <https://www.gnu.org/licenses/>.  */


/* This header is separate from features.h so that the compiler can
   include it implicitly at the start of every compilation.  It must
   not itself include <features.h> or any other header that includes
   <features.h> because the implicit include comes before any feature
   test macros that may be defined in a source file before it first
   explicitly includes a system header.  GCC knows the name of this
   header in order to preinclude it.  */

/* glibc's intent is to support the IEC 559 math functionality, real
   and complex.  If the GCC (4.9 and later) predefined macros
   specifying compiler intent are available, use them to determine
   whether the overall intent is to support these features; otherwise,
   presume an older compiler has intent to support these features and
   define these macros by default.  */



/* wchar_t uses Unicode 10.0.0.  Version 10.0 of the Unicode Standard is
   synchronized with ISO/IEC 10646:2017, fifth edition, plus
   the following additions from Amendment 1 to the fifth edition:
   - 56 emoji characters
   - 285 hentaigana
   - 3 additional Zanabazar Square characters */

!
! Copyright (C) 2003 A. Smogunov
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
subroutine free_mem
!
! Deallocates memory
!
  use cond
  implicit none
!
! From allocate_cond
!
  deallocate(psiperl)
  deallocate(zkl)
  deallocate(zkrl)
  deallocate(psipers)
  deallocate(zks)
  deallocate(zkrs)
  deallocate(psiperr)
  deallocate(zkr)
  deallocate(zkrr)

  deallocate(newbg)

  deallocate(fun0)
  deallocate(fun1)
  deallocate(fund0)
  deallocate(fund1)

  IF (lorb) THEN
    deallocate( funz0 )
    deallocate( korbl )
    deallocate( korbr )
  ENDIF

  IF (norbf>0) THEN
     deallocate(funl0)
     deallocate(funl1)
     deallocate(fundl0)
     deallocate(fundl1)

     deallocate(intw1)
     deallocate(intw2)
  END IF

  deallocate(kvall)
  deallocate(kfunl)
  deallocate(kfundl)
  IF (nocrosl>0) THEN
     deallocate(kintl)
     deallocate(kcoefl)
  END IF

  if (ikind.ne.0) then
    deallocate(kvalr)
    deallocate(kfunr)
    deallocate(kfundr)
    IF (nocrosr>0) THEN
       deallocate(kintr)
       deallocate(kcoefr)
    END IF
  endif
!
! From init_gper
!
  if (lorb) deallocate( nl_2ds )
  if (lorb) deallocate( nl_2d )
  deallocate(gper)
  deallocate(ninsh)
  deallocate(gnsh)

  return
end subroutine free_mem
